image: node:14

variables:
  NPM_TOKEN: ${CI_JOB_TOKEN}

include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'

stages:
  - test
  - build
  - release

default:
  before_script:
    - |
      {
        echo "@rotera.ai:registry=https://${ROTERA_GITLAB_HOST}/api/v4/projects/${ROTERA_GITLAB_REGISTRY_ID}/packages/npm/"
        echo "//${ROTERA_GITLAB_HOST}/api/v4/projects/${ROTERA_GITLAB_REGISTRY_ID}/packages/npm/:_authToken=${ROTERA_REGISTRY_TOKEN}"
      } | tee .npmrc
    - |
      {
        echo "{"
        echo "  \"branches\": [\"main\"],"
        echo "  \"plugins\": ["
        echo "    \"@semantic-release/commit-analyzer\","
        echo "    \"@semantic-release/release-notes-generator\","
        echo "    [\"@semantic-release/gitlab\", {"
        echo "      \"gitlabUrl\": \"https://${ROTERA_GITLAB_HOST}\","
        echo "      \"assets\": []"
        echo "    }],"
        echo "    \"@semantic-release/npm\""
        echo "  ]"
       echo "}"
      } | tee .nreleaserc.json
    - yarn config set cache-folder .yarn
    - yarn install --no-lockfile

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - node_modules/
    - .yarn

unit_test:
  stage: test
  script:
    - cat .npmrc
    - yarn test
    - yarn build
  artifacts:
    when: always
    reports:
      cobertura:
        - additional-artifacts/cobertura-coverage.xml
      junit:
        - additional-artifacts/test-report.xml
    paths:
      - dist/
      - additional-artifacts/

# Transpile the code to JS
build_typescript:
  stage: build
  script:
    - yarn build
  artifacts:
    paths:
      - dist/

publish:
  stage: release
  script:
    - npx semantic-release
  rules:
    - if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PROJECT_ROOT_NAMESPACE == "rotera.ai"'
